unit coupecoupe_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, Buttons, StdCtrls,
  Inifiles; //Fichier .ini;

const
  //Ini
  IniNom_ = 'CoupeCoupe.ini';
  //-
  TagID_ = 1145262659;//'DCRC'
  //-
  BufMax_ = 65535;
  //Nb bouttons Autres
  BlkMax_ = 51;

type

  { TWdMain }
  S004_ = string

    [4];
  S255_ = string

    [255];
  //Entete - 288 octets
  Entete_ = record
    TagID: cardinal;
    DCeNom: S255_;
    DCeTaille: Qword;
    DCeBufSize: cardinal;
  end;
  //Buffer
  Buf_ = array[0..BufMax_] of byte;

  TWdMain = class(TForm)
    EdTotalCC: TEdit;
    EdTailleRec: TEdit;
    EdFicCC: TEdit;
    EdFicRec: TEdit;
    EdTailleCC: TEdit;
    EdTotalRec: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    PaFicRec: TPanel;
    PaFicCC: TPanel;
    PaTailleCC: TPanel;
    PaTailleRec: TPanel;
    PaTotalRec: TPanel;
    PaTotalCC: TPanel;
    Sp100: TSpeedButton;
    SpAutres: TSpeedButton;
    SpStopRec: TSpeedButton;
    SpFicRec: TSpeedButton;
    Sp512k: TSpeedButton;
    Sp50: TSpeedButton;
    Sp10: TSpeedButton;
    Sp5: TSpeedButton;
    Sp1: TSpeedButton;
    Sp1g: TSpeedButton;
    Sp500: TSpeedButton;
    Sp400: TSpeedButton;
    Sp300: TSpeedButton;
    Sp200: TSpeedButton;
    SpFicDec: TSpeedButton;
    SpStopDec: TSpeedButton;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Sp100Click(Sender: TObject);
    procedure Sp100kClick(Sender: TObject);
    procedure Sp10Click(Sender: TObject);
    procedure Sp200Click(Sender: TObject);
    procedure Sp1Click(Sender: TObject);
    procedure Sp300Click(Sender: TObject);
    procedure Sp400Click(Sender: TObject);
    procedure Sp500Click(Sender: TObject);
    procedure Sp1gClick(Sender: TObject);
    procedure Sp512kClick(Sender: TObject);
    procedure Sp50Click(Sender: TObject);
    procedure Sp5Click(Sender: TObject);
    procedure SpAutresClick(Sender: TObject);
    procedure SpFicRecClick(Sender: TObject);
    procedure SpFicDecClick(Sender: TObject);
    procedure SpStopDecClick(Sender: TObject);
    procedure SpStopRecClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    CCTaille: int64;
    NoTaille: int64;
    function NoToTailleInv(Taille: int64): integer;
    function NoToTaille(Select: integer): int64;
  end;

var
  WdMain: TWdMain;
  CCFichier: string;
  CCFichierSE, Ext: string;
  CCFichiersNbr: int64;
  Stop: boolean;

implementation

uses coupecoupe_autres;

{$R *.lfm}

{ TWdMain }

var
  DirExe: string;
  CCDir: string;

procedure Cardinal_en_Byte(c: cardinal; var o1, o2, o3, o4: byte);
var
  w1, w2: word;
begin
  w1 := Hi(c);
  w2 := Lo(c);
  o1 := hi(w1);
  o2 := Lo(w1);
  o3 := hi(w2);
  o4 := Lo(w2);
end;

function Byte_en_Cardinal(o1, o2, o3, o4: byte): cardinal;
begin
  Result := (o1 * 256 + o2) * 65536 + (o3 * 256 + o4);
end;

function RealToStr(Reel: real; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s); //avec 2 décimales
  Result := s;
end;

function TailleToStr(Taille: int64): string;
var
  s: string;
begin
  s := '';
  if Taille > 1024*1024*1024*1024 then
    s := RealToStr(Taille / 1000448000000, 2) + ' To'
  else
  if Taille > 1024*1024*1024 then
    s := RealToStr(Taille / 1000448000, 2) + ' Go'
  else
  if Taille > 1024*1024 then
    s := RealToStr(Taille / 1000448, 2) + ' Mo'
  else
  if Taille > 1024 then
    s := RealToStr(Taille / 1024, 2) + ' Ko'
  else
    s := IntToStr(Taille) + ' o';
  Result := s;
end;

function TWdMain.NoToTaille(Select: integer): int64;
var
  t: int64;
begin
  t := 0;
  case Select of
    //1 à 15
    //ko
    1: t := 65536; // 1-64 ko
    2: t := 131072;// 2-128 ko
    3: t := 196608;// 3-192 ko
    4: t := 262144;// 4-256 ko
    5: t := 327680;// 5-320 ko
    6: t := 393216;// 6-384 ko
    7: t := 458752;// 7-448 ko
    8: t := 524288;// 8-512 ko
    9: t := 589824;// 9-576 ko
    10: t := 655360;//10-640 ko
    11: t := 720896;//11-704 ko
    12: t := 786432;//12-768 ko
    13: t := 851968;//13-832 ko
    14: t := 917504;//14-896 ko
    15: t := 983040;//15-960 ko
    //1Mo
    //16 à 24
    16: t := 1048576;//16-1 Mo
    17: t := 2097152;//17-2 Mo
    18: t := 3014656;//18-3 Mo
    19: t := 4063232;//19-4 Mo
    20: t := 5046272;//20-5 Mo
    21: t := 6029312;//21-6 Mo
    22: t := 7012352;//22-7 Mo
    23: t := 8060928;//23-8 Mo
    24: t := 9043968;//24-9 Mo
    //10 Mo
    //25 à 33
    25: t := 10027008;//25-10 Mo
    26: t := 20054016;//26-20 Mo
    27: t := 30081024;//27-30 Mo
    28: t := 40108032;//28-40 Mo
    29: t := 50135040;//29-50 Mo
    30: t := 60162048;//30-60 Mo
    31: t := 70189056;//31-70 Mo
    32: t := 80216064;//32-80 Mo
    33: t := 90243072;//33-90 Mo
    //100 Mo
    //34 à 42
    34: t := 100270080;//34-100 Mo
    35: t := 200540160;//35-200 Mo
    36: t := 300810240;//36-300 Mo
    37: t := 401080320;//37-400 Mo
    38: t := 501350400;//38-500 Mo
    39: t := 601620480;//39-600 Mo
    40: t := 701890560;//40-700 Mo
    41: t := 802160640;//41-800 Mo
    42: t := 902430720;//42-900 Mo
    //1 Go
    //43 à 51
    43: t := 1002700800;//43-1 Go
    44: t := 2005401600;//44-2 Go
    45: t := 3008102400;//45-3 Go
    46: t := 4010803200;//46-4 Go
    47: t := 5013504000;//47-5 Go
    48: t := 6016204800;//48-6 Go
    49: t := 7018905600;//49-7 Go
    50: t := 8021606400;//50-8 Go
    51: t := 9024307200;//51-9 Go
  end;
  Result := t;
end;

function TWdMain.NoToTailleInv(Taille: int64): integer;
var
  t: integer;
begin
  t := 0;
  case Taille of
    //1 à 15
    //ko
    65536: t := 1; //  1- 64 ko
    131072: t := 2;//  2-128 ko
    196608: t := 3;//  3-192 ko
    262144: t := 4;//  4-256 ko
    327680: t := 5;//  5-320 ko
    393216: t := 6;//  6-384 ko
    458752: t := 7;//  7-448 ko
    524288: t := 8;//  8-512 ko
    589824: t := 9;//  9-576 ko
    655360: t := 10;//10-640 ko
    720896: t := 11;//11-704 ko
    786432: t := 12;//12-768 ko
    851968: t := 13;//13-832 ko
    917504: t := 14;//14-896 ko
    983040: t := 15;//15-960 ko
    //1Mo
    //16 à 24
    1048576: t := 16;//16-1 Mo
    2097152: t := 17;//17-2 Mo
    3014656: t := 18;//18-3 Mo
    4063232: t := 19;//19-4 Mo
    5046272: t := 20;//20-5 Mo
    6029312: t := 21;//21-6 Mo
    7012352: t := 22;//22-7 Mo
    8060928: t := 23;//23-8 Mo
    9043968: t := 24;//24-9 Mo
    //10 Mo
    //25 à 33
    10027008: t := 25;//25-10 Mo
    20054016: t := 26;//26-20 Mo
    30081024: t := 27;//27-30 Mo
    40108032: t := 28;//28-40 Mo
    50135040: t := 29;//29-50 Mo
    60162048: t := 30;//30-60 Mo
    70189056: t := 31;//31-70 Mo
    80216064: t := 32;//32-80 Mo
    90243072: t := 33;//33-90 Mo
    //100 Mo
    //34 à 42
    100270080: t := 34;//34-100 Mo
    200540160: t := 35;//35-200 Mo
    300810240: t := 36;//36-300 Mo
    401080320: t := 37;//37-400 Mo
    501350400: t := 38;//38-500 Mo
    601620480: t := 39;//39-600 Mo
    701890560: t := 40;//40-700 Mo
    802160640: t := 41;//41-800 Mo
    902430720: t := 42;//42-900 Mo
    //1 Go
    //43 à 51
    1002700800: t := 43;//43-1 Go
    2005401600: t := 44;//44-2 Go
    3008102400: t := 45;//45-3 Go
    4010803200: t := 46;//46-4 Go
    5013504000: t := 47;//47-5 Go
    6016204800: t := 48;//48-6 Go
    7018905600: t := 49;//49-7 Go
    8021606400: t := 50;//50-8 Go
    9024307200: t := 51; //51-9 Go
  end;
  Result := t;
end;

procedure Ini_Sauve;
var
  FIni: TiniFile;
begin
  with WdMain do
  begin
    FIni := TiniFile.Create(DirExe + IniNom_);
    FIni.WriteString('Directory', 'Last', CCDir);
    Fini.Free;
  end;
end;

procedure Ini_Lire;
var
  FIni: TiniFile;
  Fichier: string;
begin
  with WdMain do
  begin
    Fichier := DirExe + IniNom_;
    if FileExists(Fichier) then
      with WdMain do
      begin
        FIni := TiniFile.Create(Fichier);
        CCDir := FIni.ReadString('Directory', 'Last', DirExe);
        Fini.Free;
      end;
  end;
end;

procedure Msg(s: string);
begin
  WdMain.Memo1.Lines.Add(s);
end;

procedure Boutons_Clear;
begin
  with WdMain do
  begin
    Sp1g.Enabled := False;
    Sp1g.Font.Size := 10;
    Sp500.Enabled := False;
    Sp500.Font.Size := 10;
    Sp400.Enabled := False;
    Sp400.Font.Size := 10;
    Sp300.Enabled := False;
    Sp300.Font.Size := 10;
    Sp200.Enabled := False;
    Sp200.Font.Size := 10;
    Sp100.Enabled := False;
    Sp100.Font.Size := 10;
    Sp50.Enabled := False;
    Sp50.Font.Size := 10;
    Sp10.Enabled := False;
    Sp10.Font.Size := 10;
    Sp5.Enabled := False;
    Sp5.Font.Size := 10;
    Sp1.Enabled := False;
    Sp1.Font.Size := 10;
    Sp512k.Enabled := False;
    Sp512k.Font.Size := 10;
    SpAutres.Enabled := False;
    SpAutres.Font.Size := 10;
    SpStopDec.Enabled := False;
  end;
end;

procedure Decomposition(No: integer);
var
  Buf: Buf_;
  filW: file;
  //-
  DCFile: file;
  DCNom: string;
  DCEntete: Entete_;
  DCTaille: int64;
  DCFileNbr: int64;
  DCWriteNbr: int64;
  //-
  NbRead: int64;
  FileNbr: int64;
  NbreFic: integer;
  Ok: boolean;
begin
  With WdMain do
    ActiveControl:=Memo1;
  if No > 0 then
  begin
    NbreFic := Round(WdMain.CCTaille / WdMain.NoToTaille(No));
    if MessageDlg('   Nombre de fichiers : ' + IntToStr(NbreFic + 1) +
      '   Continuer ?', mtWarning, [mbYes, mbNo, mbIgnore], 0) = mrYes then
    begin
      FileNbr := 0;
      Msg('> Ouverture du fichier Source');
      AssignFile(DCFile, CCFichier);
    {$i-}
      Reset(DCFile, 1);
    {$i+}
      if Ioresult = 0 then
      begin
        Msg('> Création du fichier Cible.');
        //----- Ecriture Entete -----
        DCNom := CCFichierSE + '_0.dcrc';
        Msg('> Ecriture : ' + ExtractFileName(DCNom));
        Ok := False;
        AssignFile(filW, DCNom);
      {$i-}
        Rewrite(filW, 1);
      {$i+}
        if Ioresult = 0 then
        begin
          with DCEntete do
          begin
            //TagID='DCRC'
            TagID := TagID_;
            DCeNom := ExtractFileName(CCFichier);
            DCeTaille := WdMain.CCTaille;
            DCeBufSize := BufMax_;
          end;
        {$i-}
          BlockWrite(FilW, DCEntete, SizeOf(DCEntete), DCWriteNbr);
        {$i+}
          if Ioresult = 0 then
          begin
            Inc(FileNbr);
            if DCWriteNbr > 0 then
              Ok := True;
          end;
        {$i-}
          CloseFile(filW);
        {$i+}
        end
        else
        begin
          Msg('Erreur en création du fichier Cible.');
        end;
        if Ok then
        begin
          Msg('> ...');
          DCFileNbr := 0;
          Stop := False;
          repeat
            Inc(DCFileNbr);
            //Fichier en écriture
            DCNom := CCFichierSE + '_' + IntToStr(DCFileNbr) + '.dcrc';
            AssignFile(filW, DCNom);
          {$i-}
            Rewrite(filW, 1);
          {$i+}
            if Ioresult = 0 then
            begin
              DCTaille := 0;
              repeat
              {$i-}
                BlockRead(DCFile, Buf, SizeOf(Buf), NbRead);
              {$i+}
                if Ioresult = 0 then
                begin
                  //-
                {$i-}
                  BlockWrite(FilW, Buf, NbRead, DCWriteNbr);
                {$i+}
                  if Ioresult = 0 then
                  begin
                    Inc(DCTaille, DCWriteNbr);
                  end;
                end
                else
                begin
                  Stop := True;
                end;
                Application.ProcessMessages;
              until (Stop) or (NbRead = 0) or (DCTaille >= WdMain.NoToTaille(No));
              //-
            {$i-}
              CloseFile(filW);
            {$i+}
              Inc(FileNbr);
              WdMain.EdTotalCC.Text := IntToStr(FileNbr);
            end;
            Application.ProcessMessages;
          until (stop) or (NbRead = 0);
          if Stop then
          begin
            Msg('> Stop !');
          end;
          if NbRead = 0 then
          begin
            Msg('> Ecriture : ' + ExtractFileName(DCNom));
            Msg('> Ecriture terminée.');
            Msg('> Total des fichiers : ' + IntToStr(DCFileNbr + 1));
          end;
          //-
          Boutons_Clear;
          //-
        end;
      {$i-}
        CloseFile(DCFile);
      {$i+}
      end
      else
      begin
        Msg('> Erreur en ouverture du fichier Source.');
      end;
    end;
  end;
end;

procedure Recomposition;
var
  filR: file;
  BufR: Buf_;
  //Recomposition
  RCFile: file;
  RCNomFichier: string;
  RCNomSE: string;
  RCExt: string;
  RCWrite: int64;
  RCTaille: int64;
  //Lecture
  FichierR: string;
  DirR: string;
  EnteteR: Entete_;
  TailleR: Qword;
  TailleRTotal: Qword;
  NbRead: int64;
  FileNbr: int64;
  n: int64;
  Ok, Fin: boolean;
begin
  Ok := False;
  with WdMain do
  begin
    ActiveControl:=Memo1;
    with OpenDialog2 do
    begin
      FileName := '*.dcrc';
      if Execute then
      begin
        Memo1.Font.color := ClYellow;
        //-
        FichierR := FileName;
        DirR := ExtractFilePath(FichierR);
        Msg('> Lecture Entête.');
        AssignFile(filR, FichierR);
        {$i-}
        Reset(filR, 1);
        {$i+}
        if Ioresult = 0 then
        begin
          //----- Lecture Entete -----
          {$i-}
          NbRead := 0;
          BlockRead(FilR, EnteteR, SizeOf(EnteteR), NbRead);
          {$i+}
          if Ioresult = 0 then
          begin
            //TagID = 'DCRC'
            if EnteteR.TagID = TagId_ then
            begin
              with EnteteR do
              begin
                //TagID
                //Nom du Fichier court
                RCNomFichier := DCeNom;
                EdFicRec.Text := DCeNom;
                //Extension
                RCExt := ExtractFileExt(RCNomFichier);
                RCNomSE := Copy(RCNomFichier, 1, Length(RCNomFichier) - Length(RCExt));
                //Nom du fichier long
                RCNomFichier := DirR + DCeNom;
                //Taille
                RCTaille := DCeTaille;
                EdTailleRec.Text := ' ' + TailleToStr(RCTaille) + ' octets)';
                //BufSize:cardinal;->65535
                Ok := True;
              end;
            end
            else
            begin
              Ok := False;
              Msg('> Ce fichier n''est pas un fichier DCRC');
            end;
          end;
          {$i-}
          CloseFile(filR);
          {$i+}
          //Supprimer le fichier Entete
            {$i-} DeleteFile(FichierR); {$i+}
        end
        else
        begin
          Msg('> Erreur en ouverture du fichier Entête.');
        end;
      end;
    end;
    if Ok then
    begin
      Fin := False;
      TailleRTotal := 0;
      //----- Recomposition -----
      Msg('> Fichier Source : ' + RCNomFichier);
      AssignFile(RCFile, RCNomFichier);
      {$i-}
      Rewrite(RCFile, 1);
      {$i+}
      //On compte le fichier Entete
      FileNbr := 1;
      if Ioresult = 0 then
      begin
        Stop := False;
        n := 1;
        repeat
          FichierR := DirR + RCNomSE + '_' + IntToStr(n) + '.dcrc';
          if n = 1 then
          begin
            Msg('> Lecture : ' + ExtractFileName(FichierR));
            Msg('...');
          end;
          //----- Lecture individuelle des fichiers .dcrc -----
          if FileExists(FichierR) then
          begin
            AssignFile(filR, FichierR);
            {$i-}
            Reset(filR, 1);
            {$i+}
            if Ioresult = 0 then
            begin
              Inc(FileNbr);
              WdMain.EdTotalRec.Text := IntToStr(FileNbr);
              TailleR := 0;
              repeat
                {$i-}
                BlockRead(FilR, BufR, SizeOf(BufR), NbRead);
                {$i+}
                if Ioresult = 0 then
                begin
                  {$i-}
                  RCWrite := 0;
                  BlockWrite(RCFile, BufR, NbRead, RCWrite);
                  {$i+}
                  Inc(TailleR, RCWrite);
                end;
              until (Stop) or (NbRead = 0);
              {$i-}
              CloseFile(filR);
              {$i+}
              Inc(TailleRTotal, TailleR);
            end;
            Inc(n);
            //Supprimer le fichier
            {$i-} DeleteFile(FichierR); {$i+}
          end
          else
          begin
            Fin := True;
            Msg('> Erreur en lecture Source.');
          end;
          Application.ProcessMessages;
        until (Stop) or (Fin) or (TailleRTotal >= RCTaille);
        //-
        if TailleRTotal = RCTaille then
        begin
          Msg('> Fichier Source : ' + FichierR);
          Msg('> Lecture terminée.');
          Msg('> Total des fichiers : ' + IntToStr(FileNbr));
          Msg('> Fichier recomposé : ' + ExtractFileName(RCNomFichier));
        end;
        {$i-}
        CloseFile(RCFile);
        {$i+}
      end;
    end;
  end;
end;

procedure Coupe_Coupe;

  procedure Test_Taille(Taille: int64);
  begin
    Boutons_Clear;
    with WdMain do
    begin
      //Par block de 65536 octets
      //1 Go Mo - 7630
      if Taille > NoToTaille(43) then
      begin
        Sp1g.Enabled := True;
        Sp1g.Font.Size := 12;
      end;
      //500 Mo - 7630
      if Taille > NoToTaille(38) then
      begin
        Sp500.Enabled := True;
        Sp500.Font.Size := 12;
      end;
      //400 Mo - 6104
      if Taille > NoToTaille(37) then
      begin
        Sp400.Enabled := True;
        Sp400.Font.Size := 12;
      end;
      //300 Mo - 4578
      if Taille > NoToTaille(36) then
      begin
        Sp300.Enabled := True;
        Sp300.Font.Size := 12;
      end;
      //200 Mo - 3052 blocks
      if Taille > NoToTaille(35) then
      begin
        Sp200.Enabled := True;
        Sp200.Font.Size := 12;
      end;
      //100 Mo - 1526 blocks
      if Taille > NoToTaille(34) then
      begin
        Sp100.Enabled := True;
        Sp100.Font.Size := 12;
      end;
      //50 Mo - 763 blocks
      if Taille > NoToTaille(29) then
      begin
        Sp50.Enabled := True;
        Sp50.Font.Size := 12;
      end;
      //10 Mo - 153 blocks
      if Taille > NoToTaille(25) then
      begin
        Sp10.Enabled := True;
        Sp10.Font.Size := 12;
      end;
      //5 Mo - 77 blocks
      if Taille > NoToTaille(20) then
      begin
        Sp5.Enabled := True;
        Sp5.Font.Size := 12;
      end;
      //1 Mo - 16 blocks
      if Taille > NoToTaille(16) then
      begin
        Sp1.Enabled := True;
        Sp1.Font.Size := 12;
      end;
      //500 ko - 8 blocks
      if Taille > NoToTaille(8) then
        Sp512k.Enabled := True;
      Sp512k.Font.Size := 12;
      //Autres
      if Taille > 0 then
      begin
        SpAutres.Enabled := True;
        SpAutres.Font.Size := 12;
        SpStopDec.Enabled := True;
      end;
    end;
  end;

begin
  with WdMain do
  begin
    with OpenDialog1 do
    begin
      //InitialDir := DirExe;
      FileName := '*.*';
      if Execute then
      begin
        CCFichier := '';
        CCFichierSE := '';
        CCTaille := 0;
        Memo1.Clear;
        EdFicRec.Caption:='';
        EdTailleRec.Caption:='';
        EdTotalRec.Caption:='';
        //-
        CCFichier := FileName;
        CCDir := ExtractFilePath(FileName);
        CCTaille := FileSize(CCFichier);
        EdTailleCC.Text := ' ' + TailleToStr(CCTaille) + ' (' +
          IntToStr(CCTaille) + ' octets)';
        EdFicCC.Text := ' ' + ExtractFileName(CCFichier);
        Msg('> Ouverture du fichier');
        Msg('> Taille : ' + TailleToStr(CCTaille));
        Test_Taille(CCTaille);
        Ext := ExtractFileExt(CCFichier);
        CCFichierSE := Copy(CCFichier, 1, Length(CCFichier) - Length(Ext));
      end;
    end;
  end;
end;

procedure TWdMain.SpFicDecClick(Sender: TObject);
begin
  Coupe_Coupe;
end;

procedure TWdMain.SpStopDecClick(Sender: TObject);
begin
  Stop := True;
end;

procedure TWdMain.SpStopRecClick(Sender: TObject);
begin
  Stop := True;
end;

procedure TWdMain.Sp1gClick(Sender: TObject);
begin
  //1 Go
  Decomposition(43);
end;

procedure TWdMain.Sp512kClick(Sender: TObject);
begin
  //500 ko
  Decomposition(8);
end;

procedure TWdMain.Sp50Click(Sender: TObject);
begin
  //50 Mo
  Decomposition(29);
end;

procedure TWdMain.Sp5Click(Sender: TObject);
begin
  //5 Mo
  Decomposition(20);
end;

procedure TWdMain.SpAutresClick(Sender: TObject);
begin
  WdAutres.ShowModal;
  Decomposition(WdMain.NoTaille);
end;

procedure TWdMain.SpFicRecClick(Sender: TObject);
begin
  ShowMessage(#10#13 + '                        ' +
    'Sélectionnez le fichier "..._0.dcrc"');
  Recomposition;
end;

procedure TWdMain.Sp100kClick(Sender: TObject);
begin
  //128 ko
  Decomposition(2);
end;

procedure TWdMain.Sp10Click(Sender: TObject);
begin
  //10 Mo
  Decomposition(25);
end;

procedure TWdMain.Sp200Click(Sender: TObject);
begin
  //200 Mo
  Decomposition(35);
end;

procedure TWdMain.Sp100Click(Sender: TObject);
begin
  //100 Mo
  Decomposition(34);
end;

procedure TWdMain.Sp1Click(Sender: TObject);
begin
  //1 Mo
  Decomposition(16);
end;

procedure TWdMain.Sp300Click(Sender: TObject);
begin
  //300 Mo
  Decomposition(36);
end;

procedure TWdMain.Sp400Click(Sender: TObject);
begin
  //400 Mo
  Decomposition(37);
end;

procedure TWdMain.Sp500Click(Sender: TObject);
begin
  //500 Mo
  Decomposition(38);
end;

procedure TWdMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Stop := True;
  Ini_Sauve;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  DirExe := ExtractFilePath(Application.ExeName);
  if DirExe[Length(DirExe)] <> '\' then
    DirExe := DirExe + '\';
  Stop := False;
  //-
  Ini_Lire;
  //-
  OpenDialog1.InitialDir := CCDir;
  WdMain.NoTaille := 0;
  WdMain.CCTaille := 0;
  //Faire fichiers INI
  WdMain.NoTaille := 0;
  WdMain.CCTaille := 0;
end;

procedure TWdMain.Memo1Change(Sender: TObject);
begin

end;

end.
